package com.engine.organization.wrapper;

import com.engine.common.util.ServiceUtil;
import com.engine.core.impl.Service;
import com.engine.organization.entity.fieldset.vo.TypeTreeVO;
import com.engine.organization.entity.scheme.param.SchemeSearchParam;
import com.engine.organization.service.SchemeService;
import com.engine.organization.service.impl.SchemeServiceImpl;
import org.apache.ibatis.annotations.Param;
import weaver.hrm.User;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/9
 * @Version V1.0
 **/
public class SchemeWrapper extends Service {

    private SchemeService getSchemeService(User user) {
        return ServiceUtil.getService(SchemeServiceImpl.class, user);
    }

    /**
     * 等级方案列表
     *
     * @param params
     * @return
     */
    public Map<String, Object> listPage(Map<String, Object> params) {
        return getSchemeService(user).listPage(params);
    }

    /**
     * 新增等级方案
     *
     * @param param
     * @return
     */
    public Map<String, Object> save(SchemeSearchParam param) {
        return getSchemeService(user).save(param);
    }

    /**
     * 更新等级方案信息
     *
     * @param param
     * @return
     */
    public Map<String, Object> updateScheme(SchemeSearchParam param) {
        return getSchemeService(user).updateScheme(param);
    }

    /**
     * 更新禁用标记
     *
     * @param params
     */
    public void updateForbiddenTagById(SchemeSearchParam params) {
        getSchemeService(user).updateForbiddenTagById(params);
    }

    /**
     * 根据ID批量删除等级方案信息
     *
     * @param ids
     */
    public void deleteByIds(@Param("ids") Collection<Long> ids) {
        getSchemeService(user).deleteByIds(ids);
    }


    /**
     * 获取搜索条件
     *
     * @param params
     * @return
     */
    public Map<String, Object> getSearchCondition(Map<String, Object> params) {
        return getSchemeService(user).getSearchCondition(params);
    }


    /**
     * 获取新增表单
     *
     * @param params
     * @return
     */
    public Map<String, Object> getSchemeForm(Map<String, Object> params) {
        return getSchemeService(user).getSchemeForm(params);
    }

    /**
     * 获取列表页面按钮信息
     *
     * @return
     */
    public Map<String, Object> getTableBtn() {
        return getSchemeService(user).getTableBtn();
    }

    public List<TypeTreeVO> getTreeData() {
        return getSchemeService(user).getTreeData();
    }
}
